/*Questa  la classe che implementa la lista delle prenotazioni, 
  quindi mi serve per definire le liste che costituiscono una 
  parte delle informazioni contenute nel data_base*/
  
package SocketProgetto;

import java.util.*;
import java.io.*;
import java.net.*;

public class lista_indirizzo_data_base{

   Vector vect=new Vector(10,5);
   
public lista_indirizzo_data_base(indirizzo_data_base ind1){
    vect.add(ind1);
    }    
    
public lista_indirizzo_data_base(Vector vect1){
   vect=vect1;
   }   

public lista_indirizzo_data_base(){
   vect=new Vector(10,5);
   }

public boolean getAttivo(int index){
   return indirizzo_di_indice(index).getAttivo();
   }
   
public lista_indirizzo_data_base setAttivo(int index,boolean att){
   indirizzo_data_base ind=this.indirizzo_di_indice(index);
   ind=ind.setAttivo(att);
   vect.setElementAt(ind,index);
   return new lista_indirizzo_data_base(vect);
   }
      
public indirizzo_data_base getHead(){
   try{
      if(vect.isEmpty())
         return new indirizzo_data_base();
      indirizzo_data_base pren=(indirizzo_data_base)vect.elementAt(0);
      return pren;
      }
   catch(ArrayIndexOutOfBoundsException e){
      System.out.println("Eccezione: all'indice 0 non c' nulla; "+e);
      return new indirizzo_data_base();
      }      
   }   
   
public String getNumero_porta(int ind){
   return this.indirizzo_di_indice(ind).getNumero_porta();
   }   
   
public InetAddress getIndirizzo(int ind){
   return this.indirizzo_di_indice(ind).getIndirizzo();
   }   

public lista_indirizzo_data_base aggiungi_indirizzo(indirizzo_data_base ind1){
/*questa oparazione e' fatta dal thread che inserisce l'indirizzo all'interno della lista_indirizzo_data_base
  in modo da dare la possibilita' di ricofigurare il sistema*/  
   vect.add(ind1);
   return new lista_indirizzo_data_base(vect);
   }  
  
public lista_indirizzo_data_base aggiungi_indirizzo(String indirizzo,String num_porta){
   indirizzo_data_base ind1=new indirizzo_data_base(indirizzo,num_porta);
   vect.add(ind1);
   return new lista_indirizzo_data_base(vect);
   }
    
public lista_indirizzo_data_base cancella_indirizzo(indirizzo_data_base ind){
/*questo metodo  usato dal thread che cancella un data_base dalla lista*/
  try{
   int index=0;
   if((index=vect.indexOf(ind))>=0){    
        vect.removeElementAt(index);
        return new lista_indirizzo_data_base(vect);
        }
   else System.out.println("Nella lista non esiste l'indirizzo "+ind.stampa_indirizzo_data_base()+" quindi non e' possibile cancellarlo");
   return this;
   }
  catch(ArrayIndexOutOfBoundsException e){
   System.out.println("Errore nella 'cancella_indirizzo': "+e);
   return this;
   }  
  }  
  
  
public lista_indirizzo_data_base cancella_indirizzo(int index){
/*questo metodo  usato dal thread che cancella un data_base dalla lista*/
  try{
     vect.removeElementAt(index);
     return new lista_indirizzo_data_base(vect);
     }
  catch(ArrayIndexOutOfBoundsException e){   
     System.out.println("Nella lista non esiste l'indirizzo di indice "+index+": "+e);
     return this;
     }  
  }  


public indirizzo_data_base indirizzo_di_indice(int index){
   try{
      indirizzo_data_base ind=(indirizzo_data_base)vect.elementAt(index);
      return ind;
      }
   catch(ArrayIndexOutOfBoundsException e){
      System.out.println("L'indice "+index+" e'invalido : "+e);
      return new indirizzo_data_base();
      }
   }  
   
public int indice_dello_indirizzo(indirizzo_data_base ind){
   String str=ind.getIndirizzo().toString();
   int dim=vect.size(),i=0;
   indirizzo_data_base ind1;
   while(i<dim){
      ind1=indirizzo_di_indice(i);
      if((str.compareTo(ind1.getIndirizzo().toString()))==0)
         return i;
      i++;
      }
   return -1;
   }
   
public boolean contiene_indirizzo(indirizzo_data_base ind){
   return vect.contains(ind);
   } 
   
public int size(){
   return vect.size();
   }
   
synchronized public String stampa_lista_indirizzo_data_base(){   
   int dimensione=vect.size();
   int i=0;
   String str=new String("\n \n ===== LISTA DEGLI INDIRIZZI DEI DATA BASE ===== \n ");
   str=str.concat("\n");
   while(i<dimensione){
      str=str.concat(this.indirizzo_di_indice(i).stampa_indirizzo_data_base());
      str=str.concat("\n \n");
      i++;
      }
   return str.concat(" =============================================== \n");
   }
  
public String stampa_simple_indirizzo_data_base(int index){
	try{
		indirizzo_data_base ind=(indirizzo_data_base)vect.elementAt(index);
		return ind.stampa_simple_indirizzo_data_base();
		}
	catch(ArrayIndexOutOfBoundsException e){
		System.out.println("Errore nella stampa_simple_indirizzo_data_base(int index )): "+e);
		return new String();
		}
	}	
}

