/*thread di attivazione data base sta in attesa di una connessione che gli viene richiesta dal
thread di configurazione (thread configurazione aiuto in particolare): tramite questa connessione
vengono settati i campi di copia attiva, primo e secondo discendente di questo data base: vuol dire che
se non  copia attiva sar un diretto discendente di una copia attiva e in quanto tale deve 
essere continuamente aggiornato*/

package SocketProgetto;

import java.net.*;
import java.io.*;
import java.util.*;

public class thread_attivazione_data_base extends Thread{

lista_volo lvolo;
lista_prenotazione lprenotazione;
boolean attivo;
InetAddress primo_discendente,secondo_discendente;
data_base data;

public thread_attivazione_data_base(lista_volo lvol,lista_prenotazione lpren,
            boolean att,InetAddress primo,InetAddress secondo,data_base dat){
   lvolo=lvol;
   lprenotazione=lpren;
   attivo=att;
   primo_discendente=primo;
   secondo_discendente=secondo;
   data=dat;
   }
   
public void run(){
   try{
    ServerSocket ds=new ServerSocket(6000);  
    while(1>0){      
      Socket s=ds.accept();
      BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
      int buf_size=s.getReceiveBufferSize();
      char[] b=new char[buf_size],b9=new char[9];
      int letti=br.read(b,0,buf_size);
      System.out.println("Stringa ricevuta dal thread di attivazione Data Base -> "+new String(b,0,letti));
      int dim=new String(InetAddress.getLocalHost().toString()).length(),i,j;
      char[] b1=new char[dim];
      attivo=true;
      data.setAttivo();
      i=0;j=0;
      while(b[i]!='|'){
         b1[j]=b[i];
         i++;j++;
         }
      j=0;
      while(j<9){
         b9[j]=b1[j];   
         j++;
         }
      System.out.println("campo primo_discendente settato "+new String(b9));   
      primo_discendente=InetAddress.getByName(new String(b9));
      data.setPrimo_discendente(primo_discendente);
      i++;j=0;   
      while(b[i]!='&'){
         b1[j]=b[i];
         i++;j++;
         }        
      j=0;
      while(j<9){
         b9[j]=b1[j];   
         j++;
         }
      System.out.println("campo secondo_discendente settato "+new String(b9));
      secondo_discendente=InetAddress.getByName(new String(b9));
      data.setSecondo_discendente(secondo_discendente);
      br.close();
      s.close();
      }
     ds.close();
     }
   catch(SocketException e0){
      System.out.println("Errore nell'apertura della socket(Thread Aggiornamento Data Base): " +e0);
      }
   catch(SecurityException e1){
      System.out.println("Errore di sicurezza (Thread Aggiornamento Data Base): "+e1);
      }
   catch(IOException e2){
      System.out.println("Errore nella ricezione di dati(Thread Aggiornamento Data Base) "+e2);
      }
   catch(IllegalArgumentException e3){
      System.out.println("Errore nella connecet(Thread Aggiornamento Data Base): "+e3);
      }
   }
   
public InetAddress getPrimo_discendente(){
   return primo_discendente;
   }
   
public InetAddress getSecondo_discendente(){
   return secondo_discendente;
   }
}

