/*thread che gestisce le richieste che vengono fatte dalle agenzie aeree*/

package SocketProgetto;

import java.net.*;
import java.io.*;
import java.util.*;

public class thread_gestione_richiesta_agenzia_aer extends Thread{

ServerSocket s1;
data_base dataBase;
Socket s;
boolean attivo;
lista_volo lvolo;
lista_prenotazione lprenotazione;
InetAddress primo_discendente,secondo_discendente;
thread_attivazione_data_base attivazione;

public thread_gestione_richiesta_agenzia_aer(lista_volo lv,lista_prenotazione lp,boolean at,ServerSocket sock,
               InetAddress primo,InetAddress secondo,thread_attivazione_data_base tadb,data_base db){
   lvolo=lv;
   lprenotazione=lp;
   attivo=at;
   s1=sock;
   primo_discendente=primo;
   secondo_discendente=secondo;
   attivazione=tadb;
   dataBase=db;
   }
   
public synchronized void run(){
   try{   
     while(1>0){
      s=s1.accept();
      /*se ricevo una richiesta vuol dire che sono una copia attiva*/
      lprenotazione=dataBase.getLista_prenotazione();
      lvolo=dataBase.getLista_volo();        
      attivo=true;      
      BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
      BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
      int buf_size=s.getReceiveBufferSize();
          
      char[] b=new char[1];
      int letti=br.read(b,0,1);
      System.out.println(" Stringa ricevuta dal Data Base -> "+new String(b,0,letti));
      
      if(b[0]=='1'){
         /*vuol dire che  un'agenzia aerea ad interpellare il data bese, e che questa  solo interessata 
         a visualizzare gli orari dei voli*/
         System.out.println(lvolo.stampa_lista_volo());
         bw.write(lvolo.stampa_lista_volo(),0,lvolo.stampa_lista_volo().length());  
         bw.flush();
         s.close();
         bw.close();
         br.close();   
         }
         
      if(b[0]=='2'){/*richiesta di inserimento di un volo*/        
         char[] b2=new char[40],sigl=new char[6],arrivo=new char[10];
         char[] num=new char[2],giorn=new char[2],mes=new char[2],ora=new char[5];         
         
         int i=0,j=0;
         letti=br.read(b2,0,40);
         while(i<2){
            giorn[j]=b2[i];
            i++;j++;
            }
         j=0;i++;
         while(b2[i]!=' '){
            mes[j]=b2[i];
            i++;j++;
            }
         i++;j=0;
         while(b2[i]!=' '){
            ora[j]=b2[i];
            i++;j++;
            }
         i++;j=0;
         while(b2[i]!=' '){
            arrivo[j]=b2[i];
            i++;j++;
            }
         i++;j=0;
         while(b2[i]!=' '){
            num[j]=b2[i];
            i++;j++;
            }
         int posti_richiesti=new Integer(new String(num)).intValue();   
         i++;j=0;
         while(b2[i]!='&'){
            sigl[j]=b2[i];
            i++;j++;
            }              
         volo vol=new volo(new String(giorn),new String(mes),new String(ora),new String(arrivo),posti_richiesti,new String(sigl));
         System.out.println(" Questo e' il volo che l'agenzia vuole inserire nelle liste "+vol.stampa_volo());
         lvolo=lvolo.aggiungi_volo(vol);
         prenotazione pren=new prenotazione(new String(sigl),posti_richiesti,new String(giorn),new String(mes));
         lprenotazione=lprenotazione.aggiungi_prenotazione(pren);
         String risposta=" Operazione effettuata";
         bw.write(risposta,0,risposta.length());
         bw.flush();    
            
         primo_discendente=attivazione.getPrimo_discendente();
         secondo_discendente=attivazione.getSecondo_discendente();
         //System.out.println("Primo= "+primo_discendente.toString());
         //System.out.println("Secondo= "+secondo_discendente.toString());
         thread_aggiornamento_lprenotazione_aer tap=new thread_aggiornamento_lprenotazione_aer(lprenotazione,primo_discendente,secondo_discendente);
         tap.setPriority(tap.MAX_PRIORITY);
         tap.start();
         thread_aggiornamento_lvolo tav=new thread_aggiornamento_lvolo(lvolo,primo_discendente,secondo_discendente);
         tav.setPriority(tav.MAX_PRIORITY);
         tav.start();
         
         s.close();
         bw.close();
         br.close();        
         }
         
      if(b[0]=='3'){/*richiesta di cancellazione di volo*/
         buf_size=s.getReceiveBufferSize();
         int j=0,i=1;
         char[] b3=new char[buf_size],sigl=new char[6];
         letti=br.read(b3,0,buf_size); 
         while(i<7){
            sigl[j]=b3[i];
            j++;i++;
            }
         String sigla=new String(sigl);
         int index=lvolo.indice_del_volo(sigla);
         volo vol=lvolo.volo_di_indice(index);
         System.out.println(" Volo da cancellare: "+vol.stampa_volo());         
         lvolo=lvolo.cancella_volo(sigla);
         lprenotazione=lprenotazione.cancella_prenotazione(sigla);
         String risposta=" Operazione effettuata";
         bw.write(risposta,0,risposta.length());
         bw.flush();

         primo_discendente=attivazione.getPrimo_discendente();
         secondo_discendente=attivazione.getSecondo_discendente();
         //System.out.println("Primo ="+primo_discendente.toString());
         //System.out.println("Secondo= "+secondo_discendente.toString());
         thread_aggiornamento_lprenotazione_aer tap=new thread_aggiornamento_lprenotazione_aer(lprenotazione,primo_discendente,secondo_discendente);
         tap.setPriority(Thread.MAX_PRIORITY);
         tap.start();
         thread_aggiornamento_lvolo tav=new thread_aggiornamento_lvolo(lvolo,primo_discendente,secondo_discendente);
         tav.setPriority(Thread.MAX_PRIORITY);
         tav.start();

         s.close();
         bw.close();
         br.close();      
         }
      }   
     s1.close();
     }
   catch(SocketException e0){
    try{
      System.out.println("Errore nell'apertura della socket(Thread Gestione agenzia aerea): " +e0);
      s1.close();
      }
    catch(IOException e){ }
      }
   catch(SecurityException e1){
    try{
      System.out.println("Errore di sicurezza (Thread Gestione agenzia aerea): "+e1);
      s1.close();
      }
    catch(IOException e){ }
      }
   catch(IOException e2){
    try{
      System.out.println("Errore nella ricezione di dati(Thread Gestione agenzia aerea) "+e2);
      s1.close();
      }
     catch(IOException e){ }
      }
   catch(IllegalArgumentException e3){
    try{
      System.out.println("Errore nella connecet(Thread Gestione agenzia aerea): "+e3);
      s1.close();
      }
    catch(IOException e){ }
      }
   finally{
      try{
         s.close();
         s1.close();
         }
      catch(IOException e){ }
      }
   }   
   
public void setLista_volo(lista_volo lvol){
   lvolo=lvol;
   }
   
public void setLista_prenotazione(lista_prenotazione lpren){
   lprenotazione=lpren;
   }
   
public void setPrimo_discendente(InetAddress primo){
   primo_discendente=primo;
   }
   
public void setSecondo_discendente(InetAddress secondo){
   secondo_discendente=secondo;
   }
}


