/*thread che gestisce le richieste che vengono fatte dalle agenzie turistiche*/

package SocketProgetto;

import java.net.*;
import java.io.*;
import java.util.*;

public class thread_gestione_richiesta_agenzia_tur extends Thread{

data_base dataBase;
ServerSocket s1;
Socket s;
boolean attivo;
lista_volo lvolo;
lista_prenotazione lprenotazione;
InetAddress primo_discendente,secondo_discendente;
thread_attivazione_data_base attivazione;

public thread_gestione_richiesta_agenzia_tur(lista_volo lv,lista_prenotazione lp,boolean at,ServerSocket sock,
               InetAddress primo,InetAddress secondo,thread_attivazione_data_base tadb,data_base db){
   lvolo=lv;
   lprenotazione=lp;
   attivo=at;
   s1=sock;
   primo_discendente=primo;
   secondo_discendente=secondo;
   attivazione=tadb;
   dataBase=db;
   }
   
public void run(){
   try{
     while(1>0){
      s=s1.accept();
      this.yield();
      lprenotazione=dataBase.getLista_prenotazione();
      lvolo=dataBase.getLista_volo();
      attivo=true;
      //ci perch se passo per di qui vuol dire che questa  diventata copia attiva
      BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
      BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
      
      int buf_size=s.getReceiveBufferSize();
      char[] b=new char[1];
      int letti=br.read(b,0,1);
      System.out.println(" Stringa ricevuta dal Data Base -> "+new String(b,0,letti));
      
      if(b[0]=='1'){
         /*vuol dire che  un'agenzia turistica ad interpellare il data bese, e che questa  solo interessata 
         a visualizzare gli orari dei voli*/
         System.out.println(lvolo.stampa_lista_volo());
         bw.write(lvolo.stampa_lista_volo(),0,lvolo.stampa_lista_volo().length());  
         bw.flush();
         s.close();
         bw.close();
         br.close();
         }
         
      if(b[0]=='2'){/*richiesta di prenotazione*/   
         char[] b2=new char[10],sigl=new char[6];
         letti=br.read(b2,0,10);
         int i=0;
         while(i<6){
            sigl[i]=b2[i+1];
            i++;
            }
         String sigla=new String(sigl);
         int index=lprenotazione.indice_della_prenotazione(sigla); 
         String msg=lprenotazione.prenotazione_di_indice(index).stampa_prenotazione();
         bw.write(msg,0,msg.length());
         bw.flush();
         System.out.println(" Ho inviato le info riguardanti il volo richiesto: ora chiedo se proseguire o no");
         letti=br.read(b2,0,10);       
         if(b2[0]!='&'){
            /*vuol dire che l'agenzia vuole fare la prenotazione*/
            int j=0;i=0;
            char[] num=new char[1],giorn=new char[2],mes=new char[2];
            while(i<1){
               num[j]=b2[i];
               i++;j++;
               }
            int posti_richiesti=new Integer(new String(num)).intValue();   
            i++;j=0;
            while(b2[i]!=' '){
               giorn[j]=b2[i];
               i++;j++;
               }
            i++;j=0;
            while(b2[i]!='&'){
               mes[j]=b2[i];
               i++;j++;
               }
            prenotazione prenot=new prenotazione(sigla,posti_richiesti,new String(giorn),new String(mes));
            System.out.println("\n Questa e' la prenotazione che l'agenzia vuole fare \n"+prenot.stampa_prenotazione_fatta(
                  posti_richiesti,new String(giorn),new String(mes)));
            lprenotazione=lprenotazione.fai_prenotazione(prenot);
            String risposta="";
            if(lprenotazione.prenotazione_scaduta(sigla,new String(giorn),new String(mes)))
               /*non ci si pu pi prenotare perch  scaduta la possibilit di farlo*/
               risposta=" Risposta dal data base: <<Prenotazione non accettata perche' ormai scaduta>>";
            else{ 
             if((lprenotazione.indice_della_prenotazione(sigla))==-1)
                risposta=" Risposta dal data base: <<Prenotazione non accettata perche' volo inesistente>>";
             else{   
               risposta=" Risposta dal data base: <<Operazione effettuata>>";
               risposta=risposta.concat(lprenotazione.stampa_lista_prenotazione());
                 }
               }
            bw.write(risposta,0,risposta.length());
            bw.flush(); 
                  
            primo_discendente=attivazione.getPrimo_discendente();
            secondo_discendente=attivazione.getSecondo_discendente();
            thread_aggiornamento_lprenotazione tad=new thread_aggiornamento_lprenotazione(lprenotazione,primo_discendente,secondo_discendente);
            tad.setPriority(tad.MAX_PRIORITY);
            tad.start();
            }
         s.close();
         bw.close();
         br.close();
         }
         
      if(b[0]=='3'){/*richiesta di cancellazione di una prenotazione fatta in precedenza*/
         buf_size=s.getReceiveBufferSize();
         int j=0,i=0;
         char[] b3=new char[buf_size],sigl=new char[6];
         char[] num=new char[1],giorn=new char[2],mes=new char[2];
         letti=br.read(b3,0,buf_size); 
         while(i<6){
            sigl[j]=b3[i+1];
            j++;i++;
            }
         String sigla=new String(sigl);
         i++;j=0;i++;       
         while(j<1){
            num[j]=b3[i];
            i++;j++;
            }
         int posti_richiesti=new Integer(new String(num)).intValue();   
         i++;j=0;
         while(b3[i]!=' '){
            giorn[j]=b3[i];
            i++;j++;
            }
         i++;j=0;
         while(b3[i]!='&'){
            mes[j]=b3[i];
            i++;j++;
            } 
         prenotazione pren=new prenotazione(sigla,posti_richiesti,
            new String(giorn),new String(mes));
         System.out.println(" Prenotazione da ritirare: "+pren.stampa_prenotazione_fatta(posti_richiesti,new String(giorn),new String(mes)));
         String risposta=new String();
         if(lprenotazione.prenotazione_scaduta(sigla,new String(giorn),new String(mes))) {
            risposta=" Risposta del data base: <<E' troppo tardi: non si puo' ritirare la prenotazione>>";
            risposta=risposta.concat(lprenotazione.stampa_lista_prenotazione());
            }
         else{
            lprenotazione=lprenotazione.ritira_prenotazione(pren);
            risposta=" Risposta del data base: <<Operazione effettuata>>";   
            risposta=risposta.concat(lprenotazione.stampa_lista_prenotazione());
            }
         bw.write(risposta,0,risposta.length());
         bw.flush();
         
            /*vuol dire che  il data_base attivo e quindi deve mantenere aggionati gli altri due discendenti*/
         primo_discendente=attivazione.getPrimo_discendente();
         secondo_discendente=attivazione.getSecondo_discendente();
         thread_aggiornamento_lprenotazione tad=new thread_aggiornamento_lprenotazione(lprenotazione,primo_discendente,secondo_discendente);
         tad.setPriority(Thread.MAX_PRIORITY);
         tad.start();
         
         s.close();
         bw.close();
         br.close();
         }  
      }   
      System.out.println("Finito(thread_gestione_richieste_agenzie_turistiche)");
      s1.close();
     }
   catch(SocketException e0){
    try{
      System.out.println("Errore nell'apertura della socket(Thread Gestione agenzia turistica): " +e0);
      s1.close();
      }
    catch(IOException e){ }
      }
   catch(SecurityException e1){
    try{
      System.out.println("Errore di sicurezza (Thread Gestione agenzia turistica): "+e1);
      s1.close();
      }
    catch(IOException e){ }
      }
   catch(IOException e2){
    try{
      System.out.println("Errore nella ricezione di dati(Thread Gestione agenzia turistica) "+e2);
      s1.close();
      }
     catch(IOException e){ }
      }
   catch(IllegalArgumentException e3){
    try{
      System.out.println("Errore nella connecet(Thread gestione agenzia turistica): "+e3);
      s1.close();
      }
    catch(IOException e){ }
      }
   finally{
      try{
         s.close();
         s1.close();
         }
      catch(IOException e){ }
      }
   }
   
public void setLista_prenotazione(lista_prenotazione lpren){
   lprenotazione=lpren;
   }
   
public void setPrimo_discendente(InetAddress primo){
   primo_discendente=primo;
   }
   
public void setSecondo_discendente(InetAddress secondo){
   secondo_discendente=secondo;
   }
}


