/*agenzia aerea: deve andare a modoficare ( eventualmente ) le liste dei voli, oppure pu visualizzare
le liste gi presenti; deve anche lanciare un thread che periodicamente ripulisca le liste di 
voli e prenotazioni scaduti. Se inserisce un nuovo volo, allora deve anche accedere alla lista
delle prenotazioni in modo da permettere che ci si possa prenotare*/

package SocketProgetto;

import java.io.*;
import java.net.*;

public class agenzia_aerea{

BufferedReader f3=new BufferedReader(new InputStreamReader(System.in));

public void connetti_al_name_server(int codice_operativo,volo volo1){
   try{
      InetAddress addr=InetAddress.getByName("lab2-pc04");
         /*questo  l'indirizzo del name server*/
      Socket s=new Socket(addr,5000);
      
      BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
      char[] bufff=new char[30];
      int letti=br.read(bufff,0,30);
      /*ricevo dal name server l'indirizzo e il numero di porta del data bese correntemente attivo*/
      System.out.println("\n Messaggio ricevuto : "+new String(bufff));
      s.close();
      
      System.out.println("\n Ora mi connetto al Data Base ....\n ");
      
      if (codice_operativo==1){
         /*devo leggere le liste dei voli in sola lettura*/
         leggi_lista_volo(new String(bufff));
         }
      if(codice_operativo==2){
         /*devo accedere alle liste delle prenotazioni in scrittura per aggiungere una prenotazione*/
         aggiungi_volo(new String(bufff),volo1);
         }
      if(codice_operativo==3){
         /*accedo alla lista per cancellare una prenotazione gi fatta*/
         ritira_volo(new String(bufff),volo1);
         }
      br.close();
      }
   catch(SocketException e0){
      System.out.println("Errore nell'apertura della socket(agenzia aerea): " +e0);
      }
   catch(SecurityException e1){
      System.out.println("Errore di sicurezza (agenzia aerea): "+e1);
      }
   catch(IOException e2){
      System.out.println("Errore nella ricezione di dati(agenzia aerea) "+e2);
      }
   catch(IllegalArgumentException e3){
      System.out.println("Errore nella connecet(agenzia aerea): "+e3);
      }
   }
  
protected void leggi_lista_volo(String indirizzo){
 try{
   int i=0,d=0;
   char[] ind=indirizzo.toCharArray(),buff=new char[15];
   while(i<9){
      buff[d]=ind[i];
      d++;i++;
      }
   buff[d]='\0';
   System.out.println("\n Data Base consultato "+new String(buff));
   InetAddress addr=InetAddress.getByName(new String(buff));
   Socket s=new Socket(addr,6003);
      
   BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
   BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
   
   bw.write('1'/*codice_operativo*/);
   bw.flush();
   
   int letti=1,dim_buf=s.getReceiveBufferSize();
   char[] str=new char[dim_buf];
   while(letti>0){   
      letti=br.read(str,0,dim_buf);
      if(letti>0)
         System.out.println(new String(str,0,letti));
      }
      
	System.out.print("\n Torno al menu principale ? (press any key) ");
	String str1=new String(f3.readLine());
            
   br.close();
   bw.close();
   s.close();
   }
  catch(UnknownHostException e0){
     System.out.println("Errore nella getByName (agenzia aerea): "+e0);
     }
  catch(IOException e1){
     System.out.println("Errore nell'apertura della socket (agenzia aerea): "+e1);
     }
  catch(NumberFormatException e2){
     System.out.println("Errore nella conversione del numero della porta del Data Base (agenzia aerea): "+e2);
     }
   }
 
protected void ritira_volo(String indirizzo,volo volo1){
  try{
   int i=0,d=0;
   char[] ind=indirizzo.toCharArray(),buff=new char[15];
   while(i<9){
      buff[d]=ind[i];
      d++;i++;
      }
   buff[d]='\0';
   InetAddress addr=InetAddress.getByName(new String(buff));
   Socket s=new Socket(addr,6003);
   InetAddress ia1=s.getInetAddress();
   System.out.println("\n Data Base consultato "+ia1.getHostName()+ia1.getHostAddress());
   int port=s.getPort();
   port=s.getLocalPort();
      
   BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
   BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));

   System.out.println("\n Si deve cancellare il volo "+volo1.getSigla_volo());
   String msg="3 "+volo1.getSigla_volo()+"&";
   bw.write(msg,0,msg.length());
   bw.flush(); 
    
   int letti=1,dim_buf=s.getReceiveBufferSize();    
   char[] str=new char[dim_buf];
   letti=br.read(str,0,dim_buf);
   if(letti>0)
      System.out.println(new String(str,0,letti));
        
   System.out.print("\n Torno al menu principale ? (press any key) ");
   String str1=new String(f3.readLine());   
   
   bw.close();         
   br.close();
   s.close();      
   }
  catch(UnknownHostException e0){
     System.out.println("Errore nella getByName (agenzia aerea): "+e0);
     }
  catch(IOException e1){
     System.out.println("Errore nell'apertura della socket (agenzia aerea): "+e1);
     }
  catch(NumberFormatException e2){
     System.out.println("Errore nella conversione del numero della porta del Data Base (agenzia aerea): "+e2);
     }
   }

protected void aggiungi_volo(String indirizzo,volo volo1){
  try{
   int i=0,d=0;
   char[] ind=indirizzo.toCharArray(),buff=new char[15];
   while(i<9){
      buff[d]=ind[i];
      d++;i++;
      }
   buff[d]='\0';
   InetAddress addr=InetAddress.getByName(new String(buff));
   Socket s=new Socket(addr,6003);
   InetAddress ia1=s.getInetAddress();
   System.out.println("\n Data Base consultato "+ia1.getHostName()+ia1.getHostAddress());
      
   BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
   BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
   
   String msg="2"+volo1.getGiorno_partenza()+" "+ volo1.getMese_partenza()+" "+
      volo1.getOra_partenza()+" "+volo1.getArrivo()+" "+Integer.toString(volo1.getNumero_posti())
      +" "+volo1.getSigla_volo()+"&";

   bw.write(msg,0,msg.length());
   bw.flush();
   
   int letti=1,dim_buf=s.getReceiveBufferSize();
   char[] str=new char[dim_buf];
   letti=br.read(str,0,dim_buf);
   if(letti>0)
      System.out.println(new String(str,0,letti));
      
	System.out.print("\n Torno al menu principale ? (press any key) ");
	String str1=new String(f3.readLine());
   
   bw.close();         
   br.close();
   s.close();
   }
  catch(UnknownHostException e0){
     System.out.println("Errore nella getByName (agenzia aerea): "+e0);
     }
  catch(IOException e1){
     System.out.println("Errore nell'apertura della socket (agenzia aerea): "+e1);
     }
  catch(NumberFormatException e2){
     System.out.println("Errore nella conversione del numero della porta del Data Base (agenzia aerea): "+e2);
     }
   }
}
 