/*ora devo fare il cliente dell'agenzia turistica che richiede di 
consultare la lista dei voli, e di poter prenotarsi ( nella lista delle prenotazioni )*/
/*decido che il server sia allocato nell'areoporto: il problema  che ci sono pi server e run 
time una agenzia turistica non pu sapere quale sia quella correntemente attiva: come fare?
Decido di avere un name server al quale l'agenzia rivolge le sue richieste e questo mi 
dice l'indirizzo del server attivo in quel momento; quando cade un server, quello che
prende il suo posto lo deve notificare al name server; dunque l'agenzia si collega al name server
per ricevere l'indirizzo del data base (connessione udp) al quale si connette con socket stream*/

package SocketProgetto;

import java.io.*;
import java.net.*;

public class agenzia_turistica{

BufferedReader f3=new BufferedReader(new InputStreamReader(System.in));

public void connetti_al_name_server(int codice_operativo,prenotazione pren){
   try{
      InetAddress addr=InetAddress.getByName("lab2-pc04");
         /*questo  l'indirizzo del name server*/
      Socket s=new Socket(addr,5000);      
      BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
      char[] bufff=new char[30];
      int letti=br.read(bufff,0,30);
      /*ricevo dal name server l'indirizzo e il numero di porta del data bese correntemente attivo*/
      System.out.println("\n Messaggio ricevuto : "+new String(bufff));
      s.close();
      
      System.out.println("\n Ora mi connetto al Data Base ....\n ");
      
      if (codice_operativo==1){
         /*devo leggere le liste dei voli in sola lettura*/
         leggi_lista_volo(new String(bufff));
         }
      if(codice_operativo==2){
         /*devo accedere alle liste delle prenotazioni in scrittura per aggiungere una prenotazione*/
         fare_prenotazione(new String(bufff),pren);
         }
      if(codice_operativo==3){
         /*accedo alla lista per cancellare una prenotazione gi fatta*/
         ritira_prenotazione(new String(bufff),pren);
         }
      br.close();
      }
   catch(SocketException e0){
      System.out.println("Errore nell'apertura della socket(agenzia turistica): " +e0);
      }
   catch(SecurityException e1){
      System.out.println("Errore di sicurezza (agenzia turistica): "+e1);
      }
   catch(IOException e2){
      System.out.println("Errore nella ricezione di dati(agenzia turistica) "+e2);
      }
   catch(IllegalArgumentException e3){
      System.out.println("Errore nella connecet(agenzia turistica): "+e3);
      }
   }
  
protected void leggi_lista_volo(String indirizzo){
 try{  
   int i=0,d=0;
   char[] ind=indirizzo.toCharArray(),buff=new char[15];
   while(i<9){
      buff[d]=ind[i];
      d++;i++;
      }
   buff[d]='\0';
   System.out.println("\n Data Base copnsultato "+new String(buff));
   InetAddress addr=InetAddress.getByName(new String(buff));
   Socket s=new Socket(addr,6001);
      
   BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
   BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
   
   bw.write('1'/*codice_operativo*/);
   bw.flush();
   
   int letti=1,dim_buf=s.getReceiveBufferSize();
   char[] str=new char[dim_buf];
   while(letti>0){   
      letti=br.read(str,0,dim_buf);
      if(letti>0)
         System.out.println(new String(str,0,letti));
      }
      
	System.out.print("\n Torno al menu principale ? (press any key) ");
	String str1=new String(f3.readLine());
            
   br.close();
   bw.close();
   s.close();
   }
  catch(UnknownHostException e0){
     System.out.println("Errore nella getByName (agenzia turistica): "+e0);
     }
  catch(IOException e1){
     System.out.println("Errore nell'apertura della socket (agenzia turistica): "+e1);
     }
  catch(NumberFormatException e2){
     System.out.println("Errore nella conversione del numero della porta del Data Base (agenzia turistica): "+e2);
     }
   }
 
protected void fare_prenotazione(String indirizzo,prenotazione pren){
  try{
   int i=0,d=0;
   char[] ind=indirizzo.toCharArray(),buff=new char[15];
   while(i<9){
      buff[d]=ind[i];
      d++;i++;
      }
   buff[d]='\0';
   InetAddress addr=InetAddress.getByName(new String(buff));
   Socket s=new Socket(addr,6001);
   InetAddress ia1=s.getInetAddress();
   System.out.println("\n Data Base consultato "+ia1.getHostName()+ia1.getHostAddress());
   int port=s.getPort();
   port=s.getLocalPort();
      
   BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
   BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));

   System.out.println("\n Scarica le informazioni riguardanti il volo "+pren.getSigla_volo());
   String msg="2 "+pren.getSigla_volo()+"&";
   int letti=1,dim_buf=s.getReceiveBufferSize();
   char[] str=new char[dim_buf];
   bw.write(msg,0,msg.length());
   bw.flush();
   letti=br.read(str,0,dim_buf);
   if(letti>0)
      System.out.println(new String(str,0,letti));
      
	System.out.print("\n Proseguo (y/n) ? (press any key) ");
   f3=new BufferedReader(new InputStreamReader(System.in));
	char[] str2=new String(f3.readLine()).toCharArray();
	if(str2[0]=='y'){
      msg=Integer.toString(pren.getNumero_posti_disponibili())+" "+
            pren.getGiorno_scadenza()+" "+pren.getMese_scadenza()+"&";       
      bw.write(msg,0,msg.length());
      bw.flush();   
      letti=br.read(str,0,dim_buf);
      if(letti>0)
         System.out.println("\n "+new String(str,0,letti));
      else System.out.println("\n Non ho letto nulla dal data base");
            
	   System.out.print("\n Torno al menu principale ? (press any key) ");
	   String str1=new String(f3.readLine());   
      }      
   else{
      bw.write("&",0,"&".length());
      System.out.println("\n Torno al menu principale. \n ");
      }
   bw.close();         
   br.close();
   s.close();      
   }
  catch(UnknownHostException e0){
     System.out.println("Errore nella getByName (agenzia turistica): "+e0);
     }
  catch(IOException e1){
     System.out.println("Errore nell'apertura della socket (agenzia turistica): "+e1);
     }
  catch(NumberFormatException e2){
     System.out.println("Errore nella conversione del numero della porta del Data Base (agenzia turistica): "+e2);
     }
   }

protected void ritira_prenotazione(String indirizzo,prenotazione pren){
  try{
   int i=0,d=0;
   char[] ind=indirizzo.toCharArray(),buff=new char[15];
   while(i<9){
      buff[d]=ind[i];
      d++;i++;
      }
   buff[d]='\0';
   InetAddress addr=InetAddress.getByName(new String(buff));
   Socket s=new Socket(addr,6001);
   InetAddress ia1=s.getInetAddress();
   System.out.println("\n Data Base consultato "+ia1.getHostName()+ia1.getHostAddress());
   int port=s.getPort();
   port=s.getLocalPort();
      
   BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
   BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
   
   String msg="3 "+pren.getSigla_volo()+" "+Integer.toString(pren.getNumero_posti_disponibili())+" "+
      pren.getGiorno_scadenza()+" "+pren.getMese_scadenza()+"&";

   bw.write(msg,0,msg.length());
   bw.flush();
   
   int letti=1,dim_buf=s.getReceiveBufferSize();
   char[] str=new char[dim_buf];
   letti=br.read(str,0,dim_buf);
   if(letti>0){
      System.out.println("\n "+new String(str,0,letti));
      }
   else System.out.println("\n Non ho ricevuto nulla dal data base");
      
	System.out.print("\n Torno al menu principale ? (press any key) ");
	String str1=new String(f3.readLine());
   
   bw.close();         
   br.close();
   s.close();
   }
  catch(UnknownHostException e0){
     System.out.println("Errore nella getByName (agenzia turistica): "+e0);
     }
  catch(IOException e1){
     System.out.println("Errore nell'apertura della socket (agenzia turistica): "+e1);
     }
  catch(NumberFormatException e2){
     System.out.println("Errore nella conversione del numero della porta del Data Base (agenzia turistica): "+e2);
     }
   }
}
 