/*Questa  la classe che implementa un server che possa mantrenere un data base, 
  quindi mi serve per definire la tabella all'interno della quale c' la lista 
  dei data base collegati e raggiungibili. Deve essere possibile riconfigurare la rete*/

package SocketProgetto;

import java.net.*;

public class indirizzo_data_base{

String num_porta;
boolean attivo;
InetAddress indirizzo;

public indirizzo_data_base(String str1,String str2){
  try{
   indirizzo=InetAddress.getByName(str1);/*questo  un indirizzo fisico*/
   num_porta=str2;
   attivo=false;
   }
  catch(UnknownHostException e){
     System.out.println(e);
     }
   }
   
public indirizzo_data_base(InetAddress str1,String str2){
   indirizzo=str1;
   num_porta=str2;
   attivo=false;
   }

public indirizzo_data_base(String str1,String str2,boolean att){
  try{
   indirizzo=InetAddress.getByName(str1);
   num_porta=str2;
   attivo=att;
   }
   catch(UnknownHostException e){
     System.out.println(e);
     }
   }

public indirizzo_data_base(InetAddress str1,String str2,boolean att){
   indirizzo=str1;
   num_porta=str2;
   attivo=att;
   }
   
public indirizzo_data_base(){
  try{
   indirizzo=InetAddress.getByName(new String(""));
   num_porta=new String("");
   attivo=false;
   }
   catch(UnknownHostException e){
     System.out.println(e);
     }
   }

public boolean getAttivo(){
   return attivo;
   }
  
public indirizzo_data_base setAttivo(boolean att){
   return new indirizzo_data_base(this.getIndirizzo(),this.getNumero_porta(),att);
   }
   
public InetAddress getIndirizzo(){
   return indirizzo;
   }
   
public String getNumero_porta(){
   return num_porta;
   }
   
public String stampa_indirizzo_data_base(){
   String str=new String("\n"+"Indirizzo = "+this.getIndirizzo()+"\n");
   str=str.concat("Numero di porta = "+this.getNumero_porta()+"\n");
   return str.concat("Campo attivo = "+this.getAttivo());
   }
   
public String stampa_simple_indirizzo_data_base(){
   return new String(this.getIndirizzo()+","+this.getNumero_porta());
   }
}
   