/*Questa  la classe che implementa la lista dei voli, quindi mi serve per definire le
  liste che costituiscono una parte delle informazioni contenute nel data_base*/
  
package SocketProgetto;

import java.util.*;

public class lista_volo{
   
   Vector vect=new Vector(10,5);
   
public lista_volo(volo volo1){
    vect.add(volo1);
    }
    
public lista_volo(Vector vect1){
   vect=vect1;
   }
   
public lista_volo(){
   vect=new Vector(10,5);
   }

public int size(){
   return vect.size();
   }
      
public volo getHead(){
   try{
      if(vect.isEmpty())
         return new volo();
      volo volo1=(volo)vect.elementAt(0);
      return volo1;
      }
   catch(ArrayIndexOutOfBoundsException e){
      System.out.println("Eccezione: all'indice 0 non c' nulla; "+e);
      return new volo();
      }      
   }

public String getGiorno_partenza(int ind){
   return this.volo_di_indice(ind).getGiorno_partenza();
   }
   
public String getMese_partenza(int ind){
   return this.volo_di_indice(ind).getMese_partenza();
   }
   
public String getOra_partenza(int ind){
   return this.volo_di_indice(ind).getOra_partenza();
   }
   
public String getArrivo(int ind){
   return this.volo_di_indice(ind).getArrivo();
   }
   
public int getNumero_posti(int ind){
   return this.volo_di_indice(ind).getNumero_posti();
   }
   
public String getSigla_volo(int ind){
   return this.volo_di_indice(ind).getSigla_volo();
   }
   
public lista_volo aggiungi_volo(volo volo1){
   vect.add(volo1);
   return new lista_volo(vect);
   }
   
public lista_volo aggiungi_volo(String sigla,String giorno,String mese,String ora,String arrivo,int num){
   volo volo1=new volo(giorno,mese,ora,arrivo,num,sigla);
   return new lista_volo(volo1);
   }
   
public lista_volo cancella_volo(String sigla){
/*questo metodo  usato dall'agenzia di aerei che cancella un 
volo perch non pi fruibile (e magari l'avr sostituito con un altro)*/
  try{
   int dimensione=vect.size(),i=0;
   while(i<dimensione){
      if((sigla.compareTo(this.volo_di_indice(i).getSigla_volo()))==0){    
           vect.removeElementAt(i);
           return new lista_volo(vect);
           }
      i++;
      }
   System.out.println("Nella lista dei voli non esiste quello con la sigla "+sigla+" quindi non e' possibile cancellarlo");
   return this;
   }
  catch(ArrayIndexOutOfBoundsException e){
   System.out.println("Errore nella 'cancella_volo (non e' possibile cancellare il volo): "+e);
   return this;
   }  
  }

public boolean contiene_volo(String sigla){
   int dimensione=vect.size();
   int i=0;
   while(i<dimensione){
      if((sigla.compareTo(this.volo_di_indice(i).getSigla_volo()))==0)
         return true;
      i++;
      }
   return false;
   }

public int indice_del_volo(volo volo1){
   return vect.indexOf(volo1);
   }
   
public int indice_del_volo(String sigla){
   int dimensione=vect.size();
   int i=0;
   while(i<dimensione){
      if ((sigla.compareTo(this.volo_di_indice(i).getSigla_volo()))==0)
         return i;
      i++;
      }
   System.out.println("Non c'e' nessun volo con la sigla "+sigla);
   return -1;
   }   
   
public volo volo_di_indice(int index){
   try{
      volo volo1=(volo)vect.elementAt(index);
      return volo1;
      }
   catch(ArrayIndexOutOfBoundsException e){
      System.out.println("L'indice "+index+" e'invalido : "+e);
      return new volo();
      }
   }   
   
public String stampa_lista_volo(){   
   int dimensione=vect.size();
   int i=0;
   String str=new String("\n LISTA DEI VOLI \n \n");
   while(i<dimensione){
      str=str.concat(this.volo_di_indice(i).stampa_volo()+"\n");
      i++;
      }
   return str;
   }
}
