package SocketProgetto;

import java.net.*;
import java.io.*;
import java.util.*;

public class thread_configurazione_aiuto extends Thread{

int[] indici;
MulticastSocket s;
lista_indirizzo_data_base lista;
InetAddress addr;
int contatore;
boolean flag;
thread_di_configurazione tdc;

public thread_configurazione_aiuto(int[] indic,MulticastSocket ms,lista_indirizzo_data_base list,boolean fl,thread_di_configurazione tt){
   indici=indic;
   s=ms;
   lista=list;
   flag=fl;
   tdc=tt;
   }
   
public void run(){
  try{    
    addr=InetAddress.getByName("224.0.0.100");      
    byte[] buff=addr.toString().getBytes();
    int length=addr.toString().length();
    DatagramPacket p=new DatagramPacket(buff,length,addr,5999);
    /*tutti i data base ricevono sulla porta 5999 i messaggi di tipo isAlive*/
    byte ttl=1; 
    this.sleep(40000);

    while(1>0){
      int i,index;
      indici=tdc.getIndici();
      lista=tdc.getLista_indirizzo_data_base();
      if((i=ci_sono_tutti(lista.size(),indici))>0){
            index=manca_attivo(lista,indici);
         //vuol dire che manca il data base che era attivo fino al ciclo precedente
            lista=elimina_chi_manca(lista,indici);
            int dimensione=lista.size();
            System.out.println("Nuova lista: \n"+lista.stampa_lista_indirizzo_data_base());
            lista=lista.setAttivo(index % dimensione,true);
            tdc.setLista_indirizzo_data_base(lista);               
            indirizzo_data_base ind0=lista.indirizzo_di_indice(index % dimensione);
            //questo data base  sicuramente aggiornato(date le solite ipotesi di guasto singolo;
            //ora devo aggiornare solo i 2 data base successivi: dico 2 per maggiore sicurezza
            indirizzo_data_base ind1=lista.indirizzo_di_indice((index+1)%dimensione);
            indirizzo_data_base ind2=lista.indirizzo_di_indice((index+2)%dimensione);
            System.out.println("ind0 = "+ind0.stampa_indirizzo_data_base());
            System.out.println("ind1 = "+ind1.stampa_indirizzo_data_base());
            System.out.println("ind2 = "+ind2.stampa_indirizzo_data_base());
            
            InetAddress addr0=ind0.getIndirizzo();
            InetAddress addr1=ind1.getIndirizzo();
            InetAddress addr2=ind2.getIndirizzo();
            Socket s0=new Socket(addr0,6000);
            BufferedWriter bw0=new BufferedWriter(new OutputStreamWriter(s0.getOutputStream()));
            int dim_buf=s.getReceiveBufferSize();            
            char[] str=new char[dim_buf];
            String str1=new String(addr1.toString())+"|"+new String(addr2.toString())+"&";
            System.out.println("stringa da mandare a "+addr0.toString()+" "+str1);
            bw0.write(str1,0,str1.length());
            bw0.flush();
            bw0.close();            
            s0.close();
         }//fine if(ci_sono_tutti)
      else System.out.println("La lista e' rimasta come prima: "+lista.stampa_lista_indirizzo_data_base());
      int[] indici1={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
      tdc.setIndici(indici1);
      indici=indici1;      
      flag=false;
      tdc.setFlag(flag);
      s.send(p,ttl);
      System.out.println("Il pacchetto di multicast e' partito "+new String(p.getData()));
      this.sleep(80000);
     }//fine while
   }//fine try
    
   catch(IOException e0){
      System.out.println("Errore nella creazione di una Socket(thread_configurazione_aiuto): "+e0);
      } 
   catch(NumberFormatException e2){
      System.out.println("Errore nella conversione del numero della porta del Data Base (thread_configurazione_aiuto): "+e2);
      }
   catch(InterruptedException e3){
      System.out.println("Errore nella sleep (thread_configurazione_auito): "+e3);
      }
   finally{
    try{
      s.leaveGroup(addr);
      s.close();   
      System.out.println("Fine di un ciclo");
      }
    catch(IOException e){ }
    }
   }//fine run
   
protected int ci_sono_tutti(int size,int[] indici){
/*ritorna 0 se ci sono tutti, altrimenti ritorna il numero di indirizzi che mancano*/
   int cont=0,i=0;
   while(i<10){
      if(indici[i]!=-1)
         cont++;
      i++;
      }
   return(size-cont);
   }   
 
protected int manca_attivo(lista_indirizzo_data_base lista,int[] indici){
/*questo metodo comunque l'indice del data base attivo che eventualmente  ancora presente nella 
lista degli indirizzi, altrimenti ritorna 0 per default*/
   int dimensione=lista.size(),i=0,j=0;
   boolean presente=false;
   while(i<dimensione){
      presente=false;
      while((!presente)&&(j<10)){
         if(indici[j]==i)presente=true;
         j++;
         }
      if(!presente){
         if(lista.getAttivo(i))
            return i;
         lista=lista.cancella_indirizzo(i);
         }
      i++;
      j=0;
      }  
   return 0;
   }
      
protected lista_indirizzo_data_base elimina_chi_manca(lista_indirizzo_data_base lista,int[] indici){
   int dimensione=lista.size(),i=0,j=0;
   boolean presente;
   while(i<dimensione){
      presente=false;
      while((!presente)&&(j<10)){
         if(indici[j]==i)presente=true;
         j++;
         }
      if(!presente)
         lista=lista.cancella_indirizzo(i);
      i++;
      j=0;
      }  
   return lista;
   }   
}
