/*thread di configurazione che periodicamente deve mandare un messaggio di multicast
in modo che tutti i data base possano rispondere con il loro indirizzo: se questo 
thread riceve un indirizzo nuovo lo deve inserire nella tabella degli indirizzi
dei data case, altrimenti se non ne riceve alcuni, li deve considerare caduti solo
provvisoriamente.In particolare se nonn riceve l'indirizzo del data base corrente 
deve occuparsi di sostituirlo con il suo successore.*/

package SocketProgetto;

import java.net.*;
import java.io.*;
import java.util.*;

public class thread_di_configurazione extends Thread{

   
BufferedReader br;
Socket s2;
ServerSocket s1;
MulticastSocket s;
InetAddress addr;
int[] indici={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
lista_indirizzo_data_base lista;
int periodo;
boolean flag;

public thread_di_configurazione(int period,lista_indirizzo_data_base list,boolean fl){
   lista=list;
   periodo=period;
   flag=fl;
   }
   
public void run(){
   try{
      int index=0,ii=0;
      InetAddress addr=InetAddress.getByName("224.0.0.100");
      /*questo  l'indirizzo del gruppo di multicast*/      
      MulticastSocket s=new MulticastSocket(5999);
      ServerSocket s1=new ServerSocket(5998);
      s.joinGroup(addr);
      byte[] buff=addr.toString().getBytes();
      int length=addr.toString().length();
      DatagramPacket p=new DatagramPacket(buff,length,addr,5999);
      /*tutti i data base ricevono sulla porta 5999 i messaggi di tipo isAlive*/
      byte ttl=1;
      s.send(p,ttl);
      int letti;
      char[] buf=s.getLocalAddress().getLocalHost().toString().toCharArray();
      thread_configurazione_aiuto tca=new thread_configurazione_aiuto(indici,s,lista,flag,this);
      tca.setPriority(tca.MIN_PRIORITY);
      tca.start();
      while(1>0){
         s2=s1.accept();
         char[] att=new char[4];
         BufferedReader br=new BufferedReader(new InputStreamReader(s2.getInputStream()));
         letti=br.read(att,0,4);
         boolean attiv=new Boolean(new String(att)).booleanValue();
         String str=s2.getInetAddress().getHostAddress();
         s2.close();
         br.close();
         indirizzo_data_base ind=new indirizzo_data_base(str,"6000",attiv);
         System.out.println("Indirizzo da inserire nella lista : "+ind.stampa_indirizzo_data_base());
         
         if((index=lista.indice_dello_indirizzo(ind))!=-1){
            lista=lista.setAttivo(index,attiv);
            indici[ii]=index;
            ii=(ii+1)%10;
            }
         else{
            lista.aggiungi_indirizzo(ind);
            index=lista.indice_dello_indirizzo(ind);
            indici[ii]=index;
            ii=(ii+1)%10;
            }
         } 
      }
   catch(IOException e0){
      System.out.println("Errore nella creazione di una Socket(thread_di_configurazione): "+e0);
      } 
   catch(NumberFormatException e2){
      System.out.println("Errore nella conversione del numero della porta del Data Base (thread di configurazione): "+e2);
      }
   finally{
      try{
         br.close();
         s2.close();
         s1.close();
         s.leaveGroup(addr);
         s.close();
         System.out.println("Fine del thread di configurazione");
         }
      catch(IOException e){ }
      }
   }
   
public void setLista_indirizzo_data_base(lista_indirizzo_data_base list){
   lista=list;
   }
   
public void setIndici(int[] indic){
   indici=indic;
   }
   
public void setFlag(boolean fl){
   flag=fl;
   }
   
public int[] getIndici(){
   return indici;
   }
   
public lista_indirizzo_data_base getLista_indirizzo_data_base(){
   return lista;
   }
   
public boolean getFlag(){
   return flag;
   }
}
   

